abstract class Vehicle
{
	protected int position = 0;
	protected int speed;
	
	public Vehicle(){
	}
	
	public Vehicle(int pos){
		position = pos;
	}
	
	public abstract void move();
	
	public void print()
	{
		System.out.println("position = " + position);
	}
}

abstract class EngineVehicle extends Vehicle
{
	protected int gas = 100;
	
	public EngineVehicle(int gas){
		this.gas = gas;
	}
}

class Car extends Vehicle
{
	private int gas;
	
	public Car(){
		gas = 100;
	}
	
	public Car(int pos, int gas){
		position = pos;
		this.gas = gas;
	}
	
	public void move(){
		position += 10;
		gas -= 10;
	}
	
	public int getGas(){
		return gas;
	}
	
	public void print(){
		super.print();
		System.out.println("gas = " + gas);
	}
}

class Bike extends Vehicle
{
	public void move(){
		position += 1;
	}
}

public class Example
{
	public static void main(String[] args){
		Vehicle[] array = new Vehicle[3];
		array[0] = new Car(0,100);
		array[1] = new Bike();
		array[0].move();
		array[1].move();
		array[0].print();
		array[1].print();
		int gas = ((Car)array[0]).getGas();
	}
}